


/*  MOGEX bim2hrb                   */
/*  słAꉞ܂B  */



#include <stdio.h>
#include <stdlib.h>
#include "../apilib.h"

int getnum(const unsigned char *p);
int get32(const unsigned char *p);
void put32(unsigned char *p, int i);

#define MAXSIZ	4 * 1024 * 1024

int main(void)
{
	unsigned char *fbuf;
	int heap_siz, mmarea, fsiz, dsize, dofs, stksiz, wrksiz, entry, bsssiz;
	int heap_adr, i;
	int fp;
	static unsigned char sign[4] = "Hari";		/* "MOGE" .vtH[}bg */

	int argc = 4; 
	char fname[12] = "a.bim";
	char sname[12] = "a.hrb";
	char heap [12] = "0k";
	
	api_initmalloc();
	fbuf = api_malloc(MAXSIZ);

	/* p[^̎擾 */
	if (argc < 4) {
		api_putstr0(" bim2hrb appname.bim appname.hrb heap-size\n");
		return 1;
	}
	heap_siz = getnum(heap);
	mmarea = 0;

	/* t@Cǂݍ */
	fp = api_fopen(fname);
	if (fp == 0)
		goto err_bim;
	fsiz = api_fsize(fp, 0);
	if (fsiz >= MAXSIZ || fsiz < 0)
		goto err_bim;
	api_fread(fbuf, fsiz, fp);
	api_fclose(fp);

	/* wb_mF */
	if (get32(&fbuf[4]) != 0x24) {	/* t@C.textX^[gAhX */
err_form:
		api_putstr0("bim file format error\n");
		return 1;
	}
	if (get32(&fbuf[8]) != 0x24)	/* [h.textX^[gAhX */
		goto err_form;
	dsize  = get32(&fbuf[12]);		/* .dataZNVTCY */
	dofs   = get32(&fbuf[16]);		/* t@Ĉǂ.dataZNV邩 */
	stksiz = get32(&fbuf[20]);		/* X^bNTCY */
	entry  = get32(&fbuf[24]);		/* Gg|Cg */
	bsssiz = get32(&fbuf[28]);		/* bssTCY */

	/* wb_ */
	heap_adr = stksiz + dsize + bsssiz;
	heap_adr = (heap_adr + 0xf) & 0xfffffff0;	/* 16oCgPʂɐ؂グ */
	wrksiz = heap_adr + heap_siz;
	wrksiz = (wrksiz + 0xfff) & 0xfffff000;		/* 4KBPʂɐ؂グ */
	put32(&fbuf[ 0], wrksiz);
	for (i = 0; i < 4; i++)
		fbuf[4 + i] = sign[i];
	put32(&fbuf[ 8], mmarea);
	put32(&fbuf[12], stksiz);
	put32(&fbuf[16], dsize);
	put32(&fbuf[20], dofs);
	put32(&fbuf[24], 0xe9000000);
	put32(&fbuf[28], entry - 0x20);
	put32(&fbuf[32], heap_adr);

	/* t@C */
	fp = (int)api_fopenEx(sname, 0);
	if (fp == 0) {
		api_putstr0("hrb file write error\n");
		return 1;
	}
	api_fwrite(fbuf, fsiz, fp);
	api_fcloseEx(fp);

	return 0;
err_bim:
		api_putstr0("bim file read error\n");
		return 1;
}

int getnum(const unsigned char *p)
{
	int i = 0, base = 10, sign = 1;
	unsigned char c;
	if (*p == '-') {
		p++;
		sign = -1;
	}
	if (*p == '0') {
		p++;
		base = 8;
		c = *p;
		if (c >= 'a')
			c -= 'a' - 'A';
		if (c == 'X') {
			p++;
			base = 16;
		}
		if (c == 'O') {
			p++;
			base = 8;
		}
		if (c == 'B') {
			p++;
			base = 2;
		}
	}
	while (1) {
		c = *p++;
		if ('0' <= c && c <= '9')
			c -= '0'; 
		else if ('A' <= c && c <= 'F')
			c -= 'A' - 10;
		else if ('a' <= c && c <= 'f')
			c -= 'a' - 10;
		else
			break;
		if (c >= base)
			break;
		i = i * base + c;
	}
	if (c >= 'a')
		c -= 'a' - 'A';
	if (c == 'K')
		i <<= 10;
	if (c == 'M')
		i <<= 20;
	if (c == 'G')
		i <<= 30;
	return i * sign;
}

int get32(const unsigned char *p)
{
	return p[0] | p[1] << 8 | p[2] << 16 | p[3] << 24;
}

void put32(unsigned char *p, int i)
{
	p[0] =  i        & 0xff;
	p[1] = (i >>  8) & 0xff;
	p[2] = (i >> 16) & 0xff;
	p[3] = (i >> 24) & 0xff;
	return;
}

/*

memo

[ .bimt@C̍\ ]

+ 0 : .textTCY
+ 4 : t@C.textX^[gAhXi0x24j
+ 8 : [h.textX^[gAhXi0x24j
+12 : .dataTCY
+16 : t@C.dataX^[gAhX
+20 : [h.dataX^[gAhX
+24 : Gg|Cg
+28 : bss̈̃oCg
+36 : R[h

[ .hrbt@C̍\ ]

+ 0 : stack+.data+heap ̑傫i4KB̔{j
+ 4 : VOl` "Hari"
+ 8 : mmarea ̑傫i4KB̔{j
+12 : X^bNl.data]
+16 : .datãTCY
+20 : .datȁl񂪃t@Ĉǂɂ邩
+24 : 0xe9000000
+28 : GgAhX-0x20
+32 : heap̈imalloc̈jJnAhX

*/
