#include "./apilib.h"
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifndef MGXLIB_APP
#define MGXLIB_APP

#define RGB(r,g,b)		16 + r + g * 6 + b * 36

int printf(const char *format, ...) {
	va_list ap;
	char s[1000];
	int i;

	va_start(ap, format);
	i = vsprintf(s, format, ap);
	api_putstr0(s);
	va_end(ap);
	return i;
}

int puts(const char *s) {
	api_putstr0((char *)s);
	api_putstr0("\n");
	return 0;
}

void _exit(int status) {
	api_end();
	return;
}

void OutText(int win, int x, int y, int c, char *str) {
	api_putstrwin(win, x + 8, y + 29, c, strlen(str), str);
	return;
}

void OutTextL(int win, int x, int y, int c, char *str) {
	int i = 0;
	int xx = 0, yy = 0;
	while (str[i] != 0x00) {
		if (str[i] == 0x0a) {
			i++;
			xx = 0;
			yy++;
		} else if (str[i] == 0x0d) {
			i++;
			xx++;
			continue;
		}
		api_putstrwin(win, x + 8 + xx * 8, y + 29 + yy * 16, c, 1, &str[i]);
		i++;
		xx++;
	}
	return;
}

void OutFillBox(int win, int col, int sx, int sy, int ex, int ey) {
	api_boxfilwin(win, sx + 8, sy + 29, ex + 8, ey + 29, col);
	return;
}

void PSet(int win, int x, int y, int col) {
	api_point(win, x + 8, y + 29, col);
	return;
}

int color_hex2code(int col) {
	int r, g, b;
	r = col & 0xff0000;
	g = col & 0x00ff00;
	b = col & 0x0000ff;
	if (r != 0) r /= 43;
	if (g != 0) g /= 43;
	if (b != 0) b /= 43;
	return 16 + r + g * 6 + b * 36;
}

#endif
