/* t@C֌W */

#include "bootpack.h"
#include "ide.h"
#include <stdio.h>
#include <string.h>
#include "ftype.h"

#define SYNC_INTVL 10

int i_sta[80][2];
extern char t[];
extern struct TASK *fdc;
extern struct CONSOLE *tcons;
extern unsigned short table_8_565[256];

void file_name(char *name, struct FILEINFO *finfo);
void file_time(struct FILEINFO *finfo);
void file_compfat(int *fat, int clustno);
void file_savesec(int location, int target);
void file_updtbl(int secno);

/* fBXNC[WFAT̈kƂ */
void file_readfat(int *fat, unsigned char *img)
{
	int i, j = 0;
	for (i = 0; i < 2880; i += 2) {
		fat[i + 0] = (img[j + 0]      | img[j + 1] << 8) & 0xfff;
		fat[i + 1] = (img[j + 1] >> 4 | img[j + 2] << 4) & 0xfff;
		j += 3;
	}
	return;
}

void file_loadfile(int clustno, int size, char *buf, int *fat, char *img)
{
	int i, secno, cyl, hed;
	int svcn, svsz, ret_flg = 0;

	svcn = svsz = 0;

	while (1) {
		secno = 0x3e00 / 512 + clustno;
		cyl = (int) secno / 36; secno %= 36;
		hed = (int) secno / 18; secno %= 18;
		if ((i_sta[cyl][hed] & (1 << secno))) {
			if (size <= 512) {
				if (ret_flg == 0) {
					for (i = 0; i < size; i++) {
						buf[i] = img[clustno * 512 + i];
					}
				}
				break;
			}
			if (ret_flg == 0) {
				for (i = 0; i < 512; i++) {
					buf[i] = img[clustno * 512 + i];
				}
			}
		} else {
			if (!ret_flg) {
				svcn = clustno;
				svsz = size;
				ret_flg = 1;
			}
			if (size <= 512)
				break;
		}
		if (!ret_flg)
			buf += 512;
		size -= 512;
		clustno = fat[clustno];
	}

	if (!ret_flg)
		return;
	clustno = svcn;
	size = svsz;

	while (1) {
		secno = 0x3e00 / 512 + clustno;
		cyl = (int) secno / 36; secno %= 36;
		hed = (int) secno / 18; secno %= 18;
		while (1) {
			if ((i_sta[cyl][hed] & (1 << secno)) != 0)
				break;
		}
		if (size <= 512) {
			for (i = 0; i < size; i++) {
				buf[i] = img[clustno * 512 + i];
			}
			break;
		}
		for (i = 0; i < 512; i++) {
			buf[i] = img[clustno * 512 + i];
		}
		buf += 512;
		size -= 512;
		clustno = fat[clustno];
	}

	return;
}

struct FILEINFO *file_search(char *name, struct FILEINFO *finfo, int max)
{
	int i, j;
	char s[12];
	for (j = 0; j < 11; j++) {
		s[j] = ' ';
	}
	j = 0;
	for (i = 0; j < 11 && name[i] != 0; i++) {
		if (name[i] == '.') {
			j = 8;
		} else {
			s[j] = name[i];
			if ('a' <= s[j] && s[j] <= 'z')
				s[j] -= 0x20;
			j++;
		}
	}
	for (i = 0; i < max; ) {
		if (finfo[i].name[0] == 0x00)
			break;
		if ((finfo[i].type & 0x18) == 0) {
			for (j = 0; j < 11; j++) {
				if (finfo[i].name[j] != s[j])
					goto next;
			}
			return finfo + i; /* t@C */
		}
next:
		i++;
	}
	return 0; /* Ȃ */
}

char *file_loadfile2(int clustno, int *psize, int *fat)
{
	int size = *psize, size2;
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	char *buf, *buf2;
	buf = (char *) memman_alloc_4k(memman, size);
	file_loadfile(clustno, size, buf, fat, (char *) (ADR_DISKIMG + 0x003e00));
	if (size >= 17) {
		size2 = tek_getsize(buf);
		if (size2 > 0) {	/* tekkĂ */
			buf2 = (char *) memman_alloc_4k(memman, size2);
			tek_decomp(buf, buf2, size2);
			memman_free_4k(memman, (int) buf, size);
			buf = buf2;
			*psize = size2;
		}
	}
	return buf;
}

int file_searchfat(int *fat)
/* FAT󂫗̈ */
{
	int i;
	for (i = 0; i < 2849; i++) {
		if (fat[i] == 0x0000) {
			io_cli();
			if (fat[i] == 0x0000) {
				fat[i] = 0x1000;
				io_sti();
				return i;
			}
			io_sti();
		}
	}
	return 0x0fff;
}

void file_clearfat(int *fat, int clustno)
{
	int nextno = fat[clustno];
	while (nextno < 0x0ff7) {
		fat[clustno] = 0x0000;
		file_compfat(fat, clustno);
		file_savesec(clustno, 2);
		clustno = nextno;
		nextno  = fat[clustno];
	}
	return;
}

int file_savefile(struct FILEHANDLE *fh, int size, int *fat, char *img)
{
	int nextno, clustno = fh->clustno, wsize = 0;
	char *buf = fh->buf;

	if (clustno >= 0x0ff8 || size == 0) {
		return 0;
	} else if (clustno) {
		if (fat[clustno] == 0x0000 || fat[clustno] >= 0x0ff8) {
			fat[clustno] = 0x0fff;
			nextno = file_searchfat(fat);
			fat[clustno] = nextno;
			file_compfat(fat, clustno);
			file_savesec(clustno, 2);
		} else {
			nextno = fat[clustno];
		}
	} else {
		nextno = fh->finfo->clustno;
	}

	while (nextno != 0x0fff) {
		clustno = nextno;
		if (size <= 512) {
			memcpy(img + clustno * 512, buf, size);
			file_savesec(clustno, 3);
			wsize += size;
			if (fat[clustno] == 0x1000) {
				fat[clustno] = 0x0fff;
				file_compfat(fat, clustno);
				file_savesec(clustno, 2);
			}
			break;
		}
		memcpy(img + clustno * 512, buf, 512);
		file_savesec(clustno, 3);
		size  -= 512;
		buf   += 512;
		wsize += 512;
		if (fat[clustno] == 0x0000 || fat[clustno] >= 0x0ff8) {
			fat[clustno] = 0x0fff;
			nextno = file_searchfat(fat);
			fat[clustno] = nextno;
			file_compfat(fat, clustno);
			file_savesec(clustno, 2);
		} else {
			nextno = fat[clustno];
		}
	}
	fh->clustno = clustno;
	file_time(fh->finfo);
	fh->finfo->size += (wsize - (fh->finfo->size % 512));
	file_savesec((int) ((char *) fh->finfo), 1);

	return wsize;
}

int file_skipfile(struct FILEHANDLE *fh, int size, int *fat, char *img, int mode)
{
	int nextno = fh->finfo->clustno;
	int clustno = 0, ssize = 0, rsize;

	if (!(mode & 0x000f)) {
		fh->finfo->size = 0;
		file_savesec((int) ((char *) fh->finfo), 1);
		return 0;
	}

	while (ssize < size - 512) {
		clustno = nextno;
		nextno  = fat[clustno];
		if (nextno >= 0x0ff8)
			break;
		ssize += 512;
	}
	rsize = size - ssize;
	if (rsize < 512) {
		memcpy(fh->buf, img + nextno * 512, rsize);
	} else if (rsize > 512) {
		rsize = 512;
		fh->finfo->size = ssize + rsize;
		file_savesec((int) ((char *) fh->finfo), 1);
	}
	fh->pos     = ssize + rsize;
	fh->bpos    = rsize % 512;
	fh->clustno = clustno;

	return fh->pos;
}

struct FILEINFO *file_insert(char *name, struct FILEINFO *finfo, int max, int *fat)
{
	int i, j = 0, clustno;
	char s[13];

	memset(s, 0, 13);
	for (i = 0; i < 12; i++) {
		if (i != 8)
			s[i] = 0x20;
	}
	for (i = 0; j < 12 && name[i] != 0; i++) {
		if (name[i] == '.') {
			j = 9;
		} else {
			s[j] = name[i];
			if ('a' <= s[j] && s[j] <= 'z') {
				s[j] -= 0x20;
			} 
			j++;
		}
	}

	for (i = 0; i < max; i++) {
		if (finfo[i].name[0] == 0x00 || finfo[i].name[0] == 0xe5) {
			clustno = file_searchfat(fat);
			if (clustno == 0x0fff)
				break;
			if (fat[clustno] == 0x1000) {
				fat[clustno] = 0x0fff;
				file_compfat(fat, clustno);
				file_savesec(clustno, 2);
			}
			strcpy(finfo[i].name, s);
			strcpy(finfo[i].ext, s + 9);
			finfo[i].type    = 0x20;
			finfo[i].clustno = clustno;
			finfo[i].size    = 0;
			file_time(&finfo[i]);
			file_savesec((int) ((char *) &finfo[i]), 1);
			return  finfo + i;
		}
	}

	return 0;
}

void file_move(char *name, struct FILEINFO *finfo)
{
	if (name != 0) {
		file_name(name, finfo);
	} else {
		finfo->name[0] = 0xe5;
	}
	file_savesec((int) ((char *) finfo), 1);
	return;
}

void file_name(char *name, struct FILEINFO *finfo)
{
	int i, j = 0;
	char s[13];

	memset(s, 0, sizeof(s));
	for (i = 0; i < 12; i++) {
		if (i != 8) s[i] = 0x20;
	}
	for (i = 0; j < 12 && name[i] != 0; i++) {
		if (name[i] == '.') {
			j = 9;
		} else {
			s[j] = name[i];
			if ('a' <= s[j] && s[j] <= 'z') s[j] -= 0x20;
			j++;
		}
	}
	strcpy(finfo->name, s);
	strcpy(finfo->ext, s + 9);

	return;
}

void file_time(struct FILEINFO *finfo)
{
	int i;
	char t16[7];
	unsigned short t10[7];

	memcpy(t16, t, 7);
	for (i = 0; i < 7; i++) {
		t10[i] = (t16[i] >> 4) * 10 + (t16[i] & 0x0f);
	}
	finfo->time = (t10[2] << 11)
				+ (t10[1] << 5)
				+ (unsigned short) (t10[0] / 2);
	finfo->date = ((t10[6] * 100 + t10[5] - 1980) << 9)
				+ (t10[4] << 5)
				+ t10[3];

	return;
}

void file_compfat(int *fat, int clustno)
{
	int clustlow, clustupp;
	unsigned char comp[3];

	clustlow = ((int) (clustno / 2)) * 2;
	clustupp = clustlow + 1;

	comp[0] = (unsigned char)  (fat[clustlow] & 0x0ff);
	comp[1] = (unsigned char) ((fat[clustupp] & 0x00f) << 4 | (fat[clustlow] & 0xf00) >> 8);
	comp[2] = (unsigned char) ((fat[clustupp] & 0xff0) >> 4);

	memcpy((char *) (ADR_DISKIMG + 0x0200 + clustlow / 2 * 3), comp, 3);
	memcpy((char *) (ADR_DISKIMG + 0x1400 + clustlow / 2 * 3), comp, 3);

	return;
}

void file_savesec(int location, int target)
{
	int i, clustlow, secno;
	int offset[2] = {0x0200, 0x1400};

	if (target == 1) {
		/* [g̈ */
		file_updtbl((int) (location - ADR_DISKIMG) / 512);
	} else if (target == 2) {
		/* FAT̈ */
		clustlow = ((int) (location / 2)) * 2;
		for (i = 0; i < 2; i++) {
			secno = (offset[i] + clustlow / 2 * 3) / 512;
			file_updtbl(secno);
			if (((offset[i] + clustlow / 2 * 3) % 512) >= 510)
				file_updtbl(secno + 1);
		}
	} else {
		/* f[^̈ */
		file_updtbl(0x3e00 / 512 + location);
	}

	return;
}

void file_updtbl(int secno)
{
	int cyl, hed;
	cyl = (int) secno / 36; secno %= 36;
	hed = (int) secno / 18; secno %= 18;
	i_sta[cyl][hed] |= (1 << secno);
	return;
}

void file_inittbl()
{
	int i, j;
	struct BOOTINFO *binfo = (struct BOOTINFO *) ADR_BOOTINFO;
	for (i = 0; i < binfo->cyls; i++) {
		for (j = 0; j < 2; j++) {
			i_sta[i][j] = 0x3ffff;
		}
	}
	return;
}

void file_list(int *fat) // uGNXv[vŃt@C邽߂̏׍HB
						 // ufiles.txtvƂt@C dir ̌ʂL^B
{
	struct FILEINFO *finfo = (struct FILEINFO *) (ADR_DISKIMG + 0x002600);
	int i, j;
	char buf[15];
	char s[5000];
	struct FILEHANDLE *fh = 0;

	strcpy(s, "");	// ȂƗ

	for (i = 0; i < 224; i++) {
		if (finfo[i].name[0] == 0x00) break;
		if (finfo[i].name[0] != 0xe5) {
			if ((finfo[i].type & 0x18) == 0) {
				sprintf(buf, "filename.ext  |  %6d", finfo[i].size);
				for (j = 0; j < 8; j++) {
					buf[j] = finfo[i].name[j];
				}
				buf[ 9] = finfo[i].ext[0];
				buf[10] = finfo[i].ext[1];
				buf[11] = finfo[i].ext[2];
				sprintf(s, "%s%s\n", s, buf);
			}
		}
	}

	hrb_api_fopen("files.txt", 0, fh, fat);
	hrb_api_fwrite(s, strlen(s), fh, fat);
	hrb_api_fclose(fh, fat);

	return;
}

int filetype_match(char *fname)
{
	char *p;
	p = fname;
	while (*p == '.')
		p++; p += 2;
	if (!strncmp(p, "txt", 3)) {
		return FTYPE_TXT;
	}
	if (!strncmp(p, "jpg", 3)) {
		return FTYPE_JPG;
	}
	if (!strncmp(p, "bmp", 3)) {
		return FTYPE_BMP;
	}
	if (!strncmp(p, "hrb", 3)) {
		return FTYPE_HRB;
	}
	if (!strncmp(p, "v", 1)) {
		return FTYPE_V;
	}
	if (!strncmp(p, "rtf", 3)) {
		return FTYPE_RTF;
	}
	return FTYPE_QQQ;
}

char *filetype_apps(int ftype, char *fname)
{
	static char cmdline[256] = "rem NoAssociation";
	if (ftype == FTYPE_TXT) {
		sprintf(cmdline, "tview %s", fname);
	}
	if (ftype == FTYPE_JPG || ftype == FTYPE_BMP) {
		sprintf(cmdline, "gview %s", fname);
	}
	if (ftype == FTYPE_HRB || ftype == FTYPE_V) {
		sprintf(cmdline, "%s", fname);
	}
	if (ftype == FTYPE_RTF) {
		sprintf(cmdline, "rtfview %s", fname);
	}
	exec(cmdline);
	return cmdline;
}

int file_read_cd(char *fname, char *buf)
{
    /*  */
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
    IDEDriver* driver = (IDEDriver *) memman_alloc_4k(memman, sizeof(IDEDriver));
    IDEDriver_IDEDriver(driver, IDE_IRQ_PRIMARY, IDE_IRQ_SECONDARY);

    /* ATAPI foCX̌ */
    int controller, deviceNo;
    if (!IDEDriver_findDevice(driver, DEVICE_ATAPI, 0x05, &controller, &deviceNo))
        return 0;

    /* ATAPI foCX̎gpJn */
    if (!IDEDriver_selectDevice(driver, controller, deviceNo))
        return 0;

    /* {{[Lqq̓ǂݍ */
    PrimaryVolumeDescriptor* pvd = (PrimaryVolumeDescriptor*) memman_alloc_4k(memman, sizeof(PrimaryVolumeDescriptor));
    IDEDriver_read(driver, 16, pvd, SECTOR_SIZE); /* 16ZN^[܂ł̓u[g̈Ȃ̂ */
    if (pvd->type[0] != ISO_PRIMARY_VOLUME_DESCRIPTOR || strncmp("CD001", pvd->id, 5) != 0)
        return 0;

    /* [gfBNgǂݍ */
    DirectoryEntry* root = (DirectoryEntry *)( pvd->root_directory_record );
    dword size = ((dword)((root->size_l + SECTOR_SIZE - 1) / SECTOR_SIZE)) * SECTOR_SIZE;
    byte* buffer = (byte *) memman_alloc_4k(memman, size);
    IDEDriver_read(driver, root->extent_l, buffer, size);
    dword position;
    for (position = 0; position < size;) {
        DirectoryEntry* dir = (DirectoryEntry *) (buffer + position);
        if (dir->size_l == 0)
            break;
		if (dir->directory == 0) {
            if (strncmp(dir->name, fname, strlen(fname)) == 0) {
                byte* data = (byte *) memman_alloc_4k(memman, size);
                IDEDriver_read(driver, dir->extent_l, data, dir->size_l);
				buf = data;
                break;
            }
        }
        position += dir->length;
    }
    memman_free_4k(memman, (int) buffer, size);
	return size;
}
