#include "bootpack.h"
#include <string.h>
#include "hankaku.h"
#include "clcfont.h"
#include "mgxfont.h"

int *tmp_fat;
extern char cpath[256], epath[1024];
#define KEYCMD_LED		0xed
#define NULL ((void*)0)

char *_hankaku;
char *_clcfont;
char *_mgxfont;

int *init_fat(char *currentpath)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;

	/* PATH̏ */
	strcpy(cpath, currentpath);
	strcpy(epath, currentpath);
	/* FAT̓WJAe[u */
	tmp_fat = (int *) memman_alloc_4k(memman, 4 * 2880);
	file_readfat(tmp_fat, (unsigned char *) (ADR_DISKIMG + 0x000200));
	file_inittbl();

	/* t@Cꗗpt@Cifile.txtj쐬 */
	file_list(tmp_fat);

	return tmp_fat;
}

void init_allowMouseKeyB()
{
	io_out8(PIC0_IMR, 0xf8);	/* PITPIC1ƃL[{[h(11111000) */
	io_out8(PIC1_IMR, 0xef);	/* }EX(11101111) */
	return;
}

void init_font(void)
{
	extern char hankaku[HANKAKU_SIZE];
	extern char clcfont[CLCFONT_SIZE];
	extern char mgxfont[MGXFONT_SIZE];

	int size;
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	char *buf;

	/* hankaku.bin */
	_hankaku = (char *) memman_alloc_4k(memman, 4096);
	memcpy(_hankaku, hankaku, HANKAKU_SIZE);
	size = tek_getsize(_hankaku);
	if (size > 0) {
		buf = (char *) memman_alloc_4k(memman, size);
		tek_decomp(_hankaku, buf, size);
		memman_free_4k(memman, (int) _hankaku, 4096);
		_hankaku = buf;
	}

	/* clockfont.bin */
	_clcfont = (char *) memman_alloc_4k(memman, 4096);
	memcpy(_clcfont, clcfont, CLCFONT_SIZE);
	size = tek_getsize(_clcfont);
	if (size > 0) {
		buf = (char *) memman_alloc_4k(memman, size);
		tek_decomp(_clcfont, buf, size);
		memman_free_4k(memman, (int) _clcfont, 4096);
		_clcfont = buf;
	}

	/* mogex.bin */
	_mgxfont = (char *) memman_alloc_4k(memman, 4096);
	memcpy(_mgxfont, mgxfont, MGXFONT_SIZE);
	size = tek_getsize(_mgxfont);
	if (size > 0) {
		buf = (char *) memman_alloc_4k(memman, size);
		tek_decomp(_mgxfont, buf, size);
		memman_free_4k(memman, (int) _mgxfont, 4096);
		_mgxfont = buf;
	}
	
}

int loadimg(short *vram, char *filename, int x, int y, int bufx, int *fat)
{
	struct BOOTINFO *binfo = (struct BOOTINFO *) ADR_BOOTINFO;
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	unsigned char *filebuf, r, g, b;
	struct DLL_STRPICENV env;
	struct RGB *picbuf;
	int info[8], fsize, xx, yy;
	struct FILEINFO *finfo = file_search(filename, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);

	if (binfo->vmode >= 16 && finfo != 0) {
		fsize   = finfo->size;
		filebuf = (unsigned char *) memman_alloc_4k(memman, fsize);
		filebuf = file_loadfile2(finfo->clustno, &fsize, tmp_fat);
		if (info_BMP(&env, info, fsize, filebuf) == 0) {
			if (info_JPEG(&env, info, fsize, filebuf) == 0)
				return 1;
		}
		picbuf = (struct RGB *) memman_alloc_4k(memman, info[2] * info[3] * sizeof(struct RGB));
		if (info[0] == 1) {
			decode0_BMP (&env, fsize, filebuf, 4, (unsigned char *) picbuf, 0);
		} else {
			decode0_JPEG(&env, fsize, filebuf, 4, (unsigned char *) picbuf, 0);
		}
		for (yy = 0; yy < info[3]; yy++) {
			for (xx = 0; xx < info[2]; xx++) {
				r = picbuf[yy * info[2] + xx].r;
				g = picbuf[yy * info[2] + xx].g;
				b = picbuf[yy * info[2] + xx].b;
				vram[(yy + y) * bufx + (xx + x)] = (unsigned short)(((r << 8) & 0xf800) | ((g << 3) & 0x07e0) | (b >> 3));
			}
		}
	} else {
		return 1;
	}
	return 0;
}

struct POINT *getimgsize(char *filename)
{
	static struct POINT pt;
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	unsigned char *filebuf;
	struct DLL_STRPICENV env;
	struct RGB *picbuf;
	int info[8], fsize;
	struct FILEINFO *finfo = file_search(filename, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);

	if (finfo != 0) {
		fsize   = finfo->size;
		filebuf = (unsigned char *) memman_alloc_4k(memman, fsize);
		filebuf = file_loadfile2(finfo->clustno, &fsize, tmp_fat);
		if (info_BMP(&env, info, fsize, filebuf) == 0) {
			if (info_JPEG(&env, info, fsize, filebuf) == 0)
				return NULL;
		}
		picbuf  = (struct RGB *) memman_alloc_4k(memman, info[2] * info[3] * sizeof(struct RGB));
		if (info[0] == 1) {
			decode0_BMP (&env, fsize, filebuf, 4, (unsigned char *)picbuf, 0);
		} else {
			decode0_JPEG(&env, fsize, filebuf, 4, (unsigned char *)picbuf, 0);
		}
		pt.x = info[2];
		pt.y = info[3];
	} else {
		return NULL;
	}
	return &pt;
}

//unsigned long chipset_read()
//{
//	io_out32(0x0CF8, 0x80000000);
//	return io_in32(0x0CFC);
//}
//
//void chipset()
//{
//	unsigned long c = chipset_read();
//	char *ch;
//
//	sprintf(ch, "0x%X", c);
//	msgbox(ch);
//	return;
//}
